org.apache.catalina.filters

## Class FilterBase

- java.lang.Object
- - org.apache.catalina.filters.FilterBase

- All Implemented Interfaces:
    Filter
  Direct Known Subclasses:
    AddDefaultCharsetFilter, CsrfPreventionFilterBase, ExpiresFilter, FailedRequestFilter, HttpHeaderSecurityFilter, RemoteCIDRFilter, RequestFilter, SetCharacterEncodingFilter

      public abstract class FilterBase
      extends Object
      implements Filter

  Base class for filters that provides generic initialisation and a simple no-op destruction.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static StringManager` | `sm`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterBase()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `destroy()` Called by the web container to indicate to a filter that it is being taken out of service.
    `protected abstract Log` | `getLogger()`
    `void` | `init(FilterConfig filterConfig)` Iterates over the configuration parameters and either logs a warning, or throws an exception for any parameter that does not have a matching setter in this filter.
    `protected boolean` | `isConfigProblemFatal()` Determines if an exception when calling a setter or an unknown configuration attribute triggers the failure of the this filter which in turn will prevent the web application from starting.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.servlet.Filter

      `doFilter`

- - ### Field Detail

    - #### sm

          protected static final StringManager sm

  - ### Constructor Detail

    - #### FilterBase

          public FilterBase()

  - ### Method Detail

    - #### getLogger

          protected abstract Log getLogger()

    - #### init

          public void init(FilterConfig filterConfig)
                    throws ServletException

      Iterates over the configuration parameters and either logs a warning, or throws an exception for any parameter that does not have a matching setter in this filter.
      Specified by:
        `init` in interface `Filter`
      Parameters:
        `filterConfig` - The configuration information associated with the filter instance being initialised
      Throws:
        `ServletException` - if `isConfigProblemFatal()` returns `true` and a configured parameter does not have a matching setter

    - #### destroy

          public void destroy()

      Description copied from interface: `javax.servlet.Filter`
      Called by the web container to indicate to a filter that it is being taken out of service. This method is only called once all threads within the filter's doFilter method have exited or after a timeout period has passed. After the web container calls this method, it will not call the doFilter method again on this instance of the filter.
      This method gives the filter an opportunity to clean up any resources that are being held (for example, memory, file handles, threads) and make sure that any persistent state is synchronized with the filter's current state in memory.
      Specified by:
        `destroy` in interface `Filter`

    - #### isConfigProblemFatal

          protected boolean isConfigProblemFatal()

      Determines if an exception when calling a setter or an unknown configuration attribute triggers the failure of the this filter which in turn will prevent the web application from starting.
      Returns:
        `true` if a problem should trigger the failure of this filter, else `false`

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.